<!DOCTYPE html>
<html>
<head>
        <meta charset="UTF-8">
        <meta name="description" content="Free Web tutorials">
        <meta name="keywords" content="HTML,CSS,XML,JavaScript">
        <meta name="author" content="Jo">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">

        <link href='https://fonts.googleapis.com/css?family=Raleway' rel='stylesheet'>
<style>

#spoiler{
      display: none;
    }

body{
    font-family: Raleway ;
    font-size: 20px;
}

.header {
  padding: 50px;
  text-align: center;
  background: #1abc9c;
  color: white;
  font-size: 35px;
}

</style>
</head>
<body>

<div class ="header">
  <h1>Binar Academy</h1>
  <p>To do Lists</p>
</div>

<form action="javascript:void(0);" method="POST"
 onsubmit="app.Add()">
<input type="text" id="add-list" placeholder="New to do list">
<input type="submit" value="Add">
</form>

<div id="spoiler" role="aria-hidden">
  <form action = "javascript:void(0);" method = "POST" id="saveEdit">
  <input type="text" id="edit-name">
  <input type="submit" id="edit-list"/>
  <a onclick="CloseInput()" aria-label="Close">&#10006;</a>
  </form>
</div>

<p id="counter"></p>
<table>
  <tr>
    <th>
      Lists
    </th>
  </tr>
  <tbody id="todo_list"></tbody>
</table>

<script>

  const button = document.querySelector('button');
  const input = document.getElementById('todo_list');

  let todo_list = localStorage.getItem('add-list') ? JSON.parse(localStorage.getItem('add-list')) : [] ;

  var app = new function(){
    this.el = document.getElementById('todo_list');
 
    this.Count = function(data){
      var el= document.getElementById('counter');
      var name = 'list';

      if(data){
        if (data> 1){
          name = 'todo_list';
        }
        el.innerHTML = data + ' ' + name;
        }
      else{
        el.innerHTML = 'No ' + name;
      }
    };

    this.FetchAll= function(){
      var data ='';

      if (todo_list.length>0){
        for (i=0; i< todo_list.length;i++){
          data += '<tr>';
          data += '<td>' + todo_list[i] + '</td>';
          data += '<td><button onclick="app.Edit(' + i + ')">Edit</button></td>';
          data += '<td><button onclick="app.Delete(' + i + ')">Delete</button></td>';
          data += '</tr>';
        }
      }

      this.Count(todo_list.length);
      return this.el.innerHTML = data ;
    };

    this.Add = function(){
      el = document.getElementById('add-list');
      var list =el.value;

      if(list){
        todo_list.push(list.trim());
        localStorage.setItem('add-list', JSON.stringify(todo_list));
        el.value = '';
        this.FetchAll();
      }
    };

    this.Edit = function (item){
      var el = document.getElementById('edit-name');
      el.value = todo_list[item];
      document.getElementById('spoiler').style.display = 'block';
      self = this;

    document.getElementById('saveEdit').onsubmit = function(){
      var list =el.value;

      if(list){
        todo_list.splice(item, 1, list.trim());
        localStorage.setItem('add-list', JSON.stringify(todo_list));
        self.FetchAll();
        CloseInput();
      }
    }
    };

    this.Delete =function(item){
      todo_list.splice(item,1);
      this.FetchAll();
    };
  
  }

app.FetchAll();

function CloseInput(){
  document.getElementById('spoiler').style.display='none';
}

button.addEventListener('click', function () {
  localStorage.clear();
  while (ul.firstChild) {
    ul.removeChild(ul.firstChild);
  }
  todo_list = [];
});

</script>  
</body>
</html>